import { readFileSync } from "fs";
import { join } from "path";

export class ProfileHandler
{

    private loadData(path:string): any
    {
        return JSON.parse(readFileSync(join(__dirname, path), "utf-8"));
    }

    public cloneProfile(gameVersion: any, profileName: string, profileData: string, profileDescKey: string): any
    {
        const cloneProfile = JSON.parse(JSON.stringify(gameVersion));
        const inventorySizeCommon = this.loadData(`${profileData}/Bonuses.json`);
        const hideoutConfigCommon = this.loadData(`${profileData}/Hideout.json`);
        const tradersConfigCommon = this.loadData(`${profileData}/Traders.json`);
        const weaponPresetsCommon = this.loadData(`${profileData}/WeaponPresets.json`);

        const loadDataContent = (pmc: string) => 
        {
            cloneProfile[pmc].descriptionLocaleKey = profileDescKey;
            cloneProfile[pmc].character.Bonuses = inventorySizeCommon;
            cloneProfile[pmc].character.Hideout = hideoutConfigCommon;
            cloneProfile[pmc].character.Info.IsStreamerModeAvailable = true;
            cloneProfile[pmc].character.Inventory = this.loadData(`${profileData}/${pmc}/Inventory.json`);
            cloneProfile[pmc].character.Skills = this.loadData(`${profileData}/${pmc}/Skills.json`);
            cloneProfile[pmc].suits = this.loadData(`${profileData}/${pmc}/Suits.json`);
            cloneProfile[pmc].trader = tradersConfigCommon;
            cloneProfile[pmc].weaponbuilds = weaponPresetsCommon;
        }

        loadDataContent("bear");
        loadDataContent("usec");

        return cloneProfile;
    }
}

